/*
 *	main.cpp - contain Win32 system rutines a OpenGL rutines	
 *  initialization part of this source was copied  from http://nehe.opengl.cz
 *
 *  Petr Kudyn (99226)
 *	PB009 - spring 2004
 *
 */
#include <math.h>
#pragma hdrstop
#include "main.h"
#include "Kernel.h"
#include "resource.h"

HDC			hDC=NULL;		// Private GDI Device Context
HGLRC		hRC=NULL;		// Permanent Rendering Context
HWND		hWnd=NULL;		// Holds Our Window Handle
HINSTANCE	hInstance;		// Holds The Instance Of The Application

bool	keys[256];			// Array Used For The Keyboard Routine
bool	active=TRUE;		// Window Active Flag Set To TRUE By Default
bool	fullscreen=TRUE;	// Fullscreen Flag Set To Fullscreen Mode By Default

GLuint base;// base letter_display_list number (firs item in array of display lists with letters) 
GLYPHMETRICSFLOAT gmf[95];// store an iformation about font

TGlobal *TheWorld;   //global object containing everything (almost:)
TGame *TheGame;      //information about game, levels, etc.
TCHAR Apath[MAX_PATH]; // program path
bool nl;   //1-if press l for next level

GLuint	filter=1;				// Which Filter To Use
GLuint	texture[3];			// Storage For 3 Textures

GLUquadricObj *quadratic;// Bude ukldat quadratic objekt


LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Declaration For WndProc

//*** create font ***
//*******************
GLvoid BuildFont(GLvoid)
{
 HFONT font;// font variable
 base = glGenLists(95);// 95 signs
 font = CreateFont(20,// height
			0,// width
			0,// angle escapement
			0,// angle orientation
			FALSE, //FW_BOLD,// bold
			FALSE,// italis
			FALSE,// underLine
			FALSE,// throughtLine
			ANSI_CHARSET,// charset
			OUT_TT_PRECIS,// output precesion (TrueType)
			CLIP_DEFAULT_PRECIS,// clip precision
			ANTIALIASED_QUALITY,// output quality
			FF_DONTCARE|DEFAULT_PITCH,// font family and pitch
			"Courier new");// font name

 SelectObject(hDC, font);// select font form DC
 
 wglUseFontOutlines(hDC,// Vybere DC
			32,// first siqn 
			95,// number of sign (form 32-space to 126)
			base,// Address of first sign
			0.0f,// edge
			0.2f,// depth on z direction
			WGL_FONT_POLYGONS,// Polygon type no wire model 
			gmf);// address of buffer for storing information
}

//**** Draw cube *****
//********************
GLvoid glDrawCube()
{
glNewList(TheWorld->view->cubeList,GL_COMPILE);
	glColor3f(0.8f,1.0f,0.8f);   //set color
	glBindTexture(GL_TEXTURE_2D, texture[BORG]); //set texure

	glBegin(GL_QUADS);
	/*	// Back Face
		glNormal3f( 0.0f, 0.0f, -1.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  -1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  -1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  -1.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  -1.0f);*/
		// Front Face1
		glNormal3f( 0.0f, 0.0f,-1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f, 1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f, 1.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f, 1.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f, 1.0f);
	/*	//Bottom  Face
		glNormal3f( 0.0f, 1.0f, 0.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  -1.0f, -1.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f,  -1.0f,  1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f,  -1.0f,  1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  -1.0f, -1.0f);*/
		// Top Face
		glNormal3f( 0.0f,-1.0f, 0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f, 1.0f, -1.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f, 1.0f, -1.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, 1.0f,  1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, 1.0f,  1.0f);
	/*	// Left Face
		glNormal3f( 1.0f, 0.0f, 0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( -1.0f, -1.0f, -1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( -1.0f,  1.0f, -1.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( -1.0f,  1.0f,  1.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( -1.0f, -1.0f,  1.0f);
		//Right Left Face
		glNormal3f(-1.0f, 0.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(1.0f, -1.0f, -1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(1.0f, -1.0f,  1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(1.0f,  1.0f,  1.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(1.0f,  1.0f, -1.0f);*/
	glEnd();
glEndList();
}

//**** Draw Border***
//*******************
GLvoid glDrawBorder()
{
glNewList(TheWorld->space.borderList,GL_COMPILE);
 glColor3f(1.0f, 1.0f, 0.0f);

glBegin(GL_LINE_STRIP); //near square
 glVertex3f(TheWorld->space.x1,TheWorld->space.y1,TheWorld->space.z1);
 glVertex3f(TheWorld->space.x2,TheWorld->space.y1,TheWorld->space.z1);
 glVertex3f(TheWorld->space.x2,TheWorld->space.y2,TheWorld->space.z1);
 glVertex3f(TheWorld->space.x1,TheWorld->space.y2,TheWorld->space.z1);
 glVertex3f(TheWorld->space.x1,TheWorld->space.y1,TheWorld->space.z1);
glEnd();

glColor3f(1.0f, 0.0f, 0.0f);
glBegin(GL_LINE_STRIP); //far square
 glVertex3f(TheWorld->space.x1,TheWorld->space.y1,TheWorld->space.z2);
 glVertex3f(TheWorld->space.x2,TheWorld->space.y1,TheWorld->space.z2);
 glVertex3f(TheWorld->space.x2,TheWorld->space.y2,TheWorld->space.z2);
 glVertex3f(TheWorld->space.x1,TheWorld->space.y2,TheWorld->space.z2);
 glVertex3f(TheWorld->space.x1,TheWorld->space.y1,TheWorld->space.z2);
glEnd();

glBegin(GL_LINES); //line between squares
glColor3f(1.0f, 1.0f, 0.0f);
 glVertex3f(TheWorld->space.x1,TheWorld->space.y1,TheWorld->space.z1);
glColor3f(1.0f, 0.0f, 0.0f);
 glVertex3f(TheWorld->space.x1,TheWorld->space.y1,TheWorld->space.z2);
glColor3f(1.0f, 1.0f, 0.0f);
 glVertex3f(TheWorld->space.x1,TheWorld->space.y2,TheWorld->space.z1);
glColor3f(1.0f, 0.0f, 0.0f);
 glVertex3f(TheWorld->space.x1,TheWorld->space.y2,TheWorld->space.z2);
glColor3f(1.0f, 1.0f, 0.0f);
 glVertex3f(TheWorld->space.x2,TheWorld->space.y1,TheWorld->space.z1);
glColor3f(1.0f, 0.0f, 0.0f);
 glVertex3f(TheWorld->space.x2,TheWorld->space.y1,TheWorld->space.z2);
glColor3f(1.0f, 1.0f, 0.0f);
 glVertex3f(TheWorld->space.x2,TheWorld->space.y2,TheWorld->space.z1);
glColor3f(1.0f, 0.0f, 0.0f);
 glVertex3f(TheWorld->space.x2,TheWorld->space.y2,TheWorld->space.z2);

glEnd();


glEndList();
}

//***** Loads A Bitmap Image ****
//*******************************
AUX_RGBImageRec *LoadBMP(char *Filename)				 
{
	FILE *File=NULL;									// File Handle

	if (!Filename)										// Make Sure A Filename Was Given
	{
		return NULL;									// If Not Return NULL
	}

	File=fopen(Filename,"r");							// Check To See If The File Exists

	if (File)											// Does The File Exist?
	{
		fclose(File);									// Close The Handle
		return auxDIBImageLoad(Filename);				// Load The Bitmap And Return A Pointer
	}

	return NULL;										// If Load Failed Return NULL
}

//**** Load Bitmaps And Convert To Textures ****
//**********************************************
int LoadGLTextures()									
{
	int Status=FALSE;									// Status Indicator

	AUX_RGBImageRec *TextureImage[2];					// Create Storage Space For The Texture

	memset(TextureImage,0,sizeof(void *)*2);           	// Set The Pointer To NULL

	// Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit
	if (TextureImage[0]=LoadBMP("data/borg.bmp"))
	{
		Status=TRUE;									// Set The Status To TRUE

		glGenTextures(1, &texture[0]);					// Create Three Textures

		// Create Nearest Filtered Texture
		glBindTexture(GL_TEXTURE_2D, texture[0]);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
	}

	if (TextureImage[0])								// If Texture Exists
	{
	 if (TextureImage[0]->data)						// If Texture Image Exists
	  free(TextureImage[0]->data);				// Free The Texture Image Memory
	  free(TextureImage[0]);							// Free The Image Structure
	 }
	
	if (TextureImage[0]=LoadBMP("data/asteroid.bmp"))
	{
		Status=TRUE;									// Set The Status To TRUE

		glGenTextures(1, &texture[1]);					// Create Three Textures

		// Create Nearest Filtered Texture
		glBindTexture(GL_TEXTURE_2D, texture[1]);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
	 }
	
	if (TextureImage[0])								// If Texture Exists
	{
	 if (TextureImage[0]->data)						// If Texture Image Exists
			free(TextureImage[0]->data);				// Free The Texture Image Memory
		free(TextureImage[0]);							// Free The Image Structure
	}

	return Status;										// Return The Status
}

//*** Resize And Initialize The GL Window ***
GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		
{
	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,width,height);						// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
}


//***  Setup For OpenGL ***
int InitGL(GLvoid)										
{
	if (!LoadGLTextures())								// Jump To Texture Loading Routine
	{
		return FALSE;									// If Texture Didn't Load Return FALSE
	}

  TheWorld->LoadObject(TheWorld->fObjects, TheGame->numAsteroids[TheGame->level-1]);            //load objects from file
	TheWorld->SetShadeModel(GL_SMOOTH);                  // Enable Smooth Shading
	
  glEnable(GL_CULL_FACE);
	glClearColor(0.0f, 0.0f, 0.0f, 0.5f);				// Black Background
	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_DONT_CARE);	// Really Nice Perspective Calculations
    
  glEnable(GL_LIGHTING);                               //enable lighting

	GLfloat color[] = {0.5f, 0.5f, 0.5f, 1.0f};          //global ambient light
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT,color);        //set global ambient
	glEnable(GL_COLOR_MATERIAL);                        //turn up material coloring 
	
	BuildFont();                                        // Create font

	glDrawBorder();                                    //create border
  glDrawCube();                                     //create borg cube


quadratic=gluNewQuadric();// Vrt ukazatel na nov quadratic
gluQuadricNormals(quadratic, GLU_SMOOTH);// Vygeneruje normlov vektory (hladk)
gluQuadricTexture(quadratic, GL_TRUE);// Vygeneruje texturov koordinty

	return TRUE;										
}


//***** Drawing scenery *****
//***************************
int DrawGLScene(GLvoid)									// Here's Where We Do All The Drawing
{
static GLenum lBuff;                                     //buffer for number of light
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear Screen And Depth Buffer
  
	glLoadIdentity();
	gluLookAt(TheWorld->view->eye[0],TheWorld->view->eye[1],TheWorld->view->eye[2],//set viewer
    TheWorld->view->pos[0],TheWorld->view->pos[1],TheWorld->view->pos[2],
    TheWorld->view->up[0],TheWorld->view->up[1],TheWorld->view->up[2]);

	
 glPushMatrix();  //draw border 
 
   glCallList(TheWorld->space.borderList);
 glPopMatrix();


 glPushMatrix();                //draw borg cube
  glEnable(GL_TEXTURE_2D);							// Enable Texture Mapping

	glTranslatef(TheWorld->view->pos[0],TheWorld->view->pos[1],
		             TheWorld->view->pos[2]); 
	glScalef(0.08f, 0.08f, 0.08f);      //set size
  glRotatef(float(TheWorld->view->angle), 0.0f,-1.0f,0.0f);
	glCallList(TheWorld->view->cubeList);  // call dipslay list with borg cube
 glPopMatrix();

	
for(int j=0; j<TheWorld->asteroids.size(); j++)
{
 glPushMatrix();
  glColor3fv(TheWorld->asteroids[j].color);   //set color
	glBindTexture(GL_TEXTURE_2D, texture[ASTEROID]); //set texure
	
	glTranslatef(TheWorld->asteroids[j].pos[0],TheWorld->asteroids[j].pos[1],
		           TheWorld->asteroids[j].pos[2]);   //translation
	glRotatef(TheWorld->asteroids[j].rot[0],1.0f,0.0f,0.0f);  //rotation  x
  glRotatef(TheWorld->asteroids[j].rot[1],0.0f,1.0f,0.0f);  // rotation y
  glRotatef(TheWorld->asteroids[j].rot[2],0.0f,0.0f,1.0f);  // rotation z
  
	gluSphere(quadratic,TheWorld->asteroids[j].radius,8,8);//asteroid
 glPopMatrix();
}

glDisable(GL_TEXTURE_2D);							// Enable Texture Mapping
 for(int i=0; i<TheWorld->numObjects; i++){            //show objects
	     glPushMatrix();                              //safe matrix with viewer location 
	  if(TheWorld->objects[i]->type==eLetter && TheWorld->objects[i]->enabled) //if letter and if visible
		{   
	
		 glTranslatef(TheWorld->objects[i]->pos[0],TheWorld->objects[i]->pos[1],
		             TheWorld->objects[i]->pos[2]);   //translation
	    glRotatef(TheWorld->objects[i]->rot[0],1.0f,0.0f,0.0f);  //rotation  x
      glRotatef(TheWorld->objects[i]->rot[1],0.0f,1.0f,0.0f);  // rotation y
      glRotatef(TheWorld->objects[i]->rot[2],0.0f,0.0f,1.0f);  // rotation z
      glScalef(static_cast<TLetter*>(TheWorld->objects[i])->scale[0],
		         static_cast<TLetter*>(TheWorld->objects[i])->scale[1],  //scale
		  			 static_cast<TLetter*>(TheWorld->objects[i])->scale[2]);
		
			glColor3fv(static_cast<TLetter*>(TheWorld->objects[i])->color); //color 
		  glPushAttrib(GL_LIST_BIT);   // safe stage of display list
      glListBase(base);            // set first list on base
		  
			
			glCallList(base -32+static_cast<TLetter*>(TheWorld->objects[i])->ascii); //show letter
		  glPopAttrib();       // get previous stage of display list
		}
		else if(TheWorld->objects[i]->type==eLight) //if light
		{		
		 lBuff=TheWorld->elights[TheWorld->objects[i]->ID]; 
		 if (TheWorld->objects[i]->enabled)    //and switch on
		 {
		   glLightfv(lBuff, GL_POSITION,TheWorld->objects[i]->pos);        //position
       glLightfv(lBuff, GL_SPOT_DIRECTION,TheWorld->objects[i]->rot);  //spot direction 
	     glLightfv(lBuff, GL_AMBIENT,static_cast<TLight*>(TheWorld->objects[i])->ambient);
	     glLightfv(lBuff, GL_DIFFUSE,static_cast<TLight*>(TheWorld->objects[i])->diffuse);
	     glLightfv(lBuff, GL_SPECULAR,static_cast<TLight*>(TheWorld->objects[i])->specular);
	     glLightf(lBuff,  GL_SPOT_EXPONENT,static_cast<TLight*>(TheWorld->objects[i])->spotExponent);
		   glLightf(lBuff,  GL_SPOT_CUTOFF,static_cast<TLight*>(TheWorld->objects[i])->spotCutOff);
       glLightf(lBuff, GL_CONSTANT_ATTENUATION,static_cast<TLight*>(TheWorld->objects[i])->attenuation[0]);
       glLightf(lBuff, GL_LINEAR_ATTENUATION,static_cast<TLight*>(TheWorld->objects[i])->attenuation[1]);
		   glLightf(lBuff, GL_QUADRATIC_ATTENUATION,static_cast<TLight*>(TheWorld->objects[i])->attenuation[2]);
	     glEnable(lBuff);
		 }
		 else
		   glDisable(lBuff);
	  }
			glPopMatrix();                       //load matrix with viewer location from LIFO

			
	}
	return TRUE;											    
}



//*** Properly Kill The Window ***
GLvoid KillGLWindow(GLvoid)								
{
  glDeleteLists(base, 95);// erase letter_display_list containing 75 signs
	
	if (fullscreen)										// Are We In Fullscreen Mode?
	{
		ChangeDisplaySettings(NULL,0);					// If So Switch Back To The Desktop
		ShowCursor(TRUE);								// Show Mouse Pointer
	}

	if (hRC)											// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))					// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;										// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;										// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))			// Are We Able To Unregister Class
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;									// Set hInstance To NULL
	}
}


//*** Creates Our OpenGL Window ***
BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;			// Holds The Results After Searching For A Match
	WNDCLASS	wc;						// Windows Class Structure
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style
	RECT		WindowRect;				// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;			// Set Left Value To 0
	WindowRect.right=(long)width;		// Set Right Value To Requested Width
	WindowRect.top=(long)0;				// Set Top Value To 0
	WindowRect.bottom=(long)height;		// Set Bottom Value To Requested Height

	fullscreen=fullscreenflag;			// Set The Global Fullscreen Flag

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			=   LoadIcon(NULL, "IDI_BORG");			// Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								// Set The Class Name

	if (!RegisterClass(&wc))									// Attempt To Register The Window Class
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}
	
	if (fullscreen)												// Attempt Fullscreen Mode?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","NeHe GL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;		// Windowed Mode Selected.  Fullscreen = FALSE
			}
			else
			{
				// Pop Up A Message Box Letting User Know The Program Is Closing.
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}

	if (fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
		dwStyle=WS_POPUP;										// Windows Style
		ShowCursor(FALSE);										// Hide Mouse Pointer
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Adjust Window To True Requested Size

	// Create The Window
	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
								"OpenGL",							// Class Name
								title,								// Window Title
								dwStyle |							// Defined Window Style
								WS_CLIPSIBLINGS |					// Required Window Style
								WS_CLIPCHILDREN | WS_MAXIMIZE,					// Required Window Style
								0, 0,								// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,								// No Parent Window
								NULL,								// No Menu
								hInstance,							// Instance
								NULL)))								// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
		1,											// Version Number
		PFD_DRAW_TO_WINDOW |						// Format Must Support Window
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							// Must Support Double Buffering
		PFD_TYPE_RGBA,								// Request An RGBA Format
		bits,										// Select Our Color Depth
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)  
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))							// Did We Get A Device Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))				// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))					// Try To Activate The Rendering Context
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);						// Show The Window
	SetForegroundWindow(hWnd);						// Slightly Higher Priority
	SetFocus(hWnd);									// Sets Keyboard Focus To The Window
	
	LPRECT rectangl; 
	rectangl=new RECT;
	GetClientRect(hWnd,rectangl);
  ReSizeGLScene(rectangl->right, rectangl->bottom);					// Set Up Our Perspective GL Screen

	if (!InitGL())									// Initialize Our Newly Created GL Window
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}
  TheWorld->objects[TheWorld->getIndex(FIRST_LEVEL_LIST)]->enabled=true; 
	return TRUE;									// Success
}

//*** callback function of main window ***
LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle For This Window
							UINT	uMsg,			// Message For This Window
							WPARAM	wParam,			// Additional Message Information
							LPARAM	lParam)			// Additional Message Information
{
 static char sBuff[100];
	switch (uMsg)									// Check For Windows Messages
	{
	case WM_CREATE:                                     //create window
 
	 SetTimer (hWnd, TIMER1, TIMER1_PERIOD, NULL) ; //setup timer
        return 0 ;


	case WM_TIMER :                         //timer
     if(TheGame->gameOver) //if you lose! start new game
	 {
	  TheGame->overTime--;  //decrement over time, when = 0 start new game
	  if(TheGame->overTime==0)
	     SendMessage(hWnd,WM_KEYUP,VK_F4,0); 
	  return 0;
	 }
	 if(!TheWorld->run)                //animation is poused
			 return 0;
	      TheWorld->incTime();              //check all function, and perform active of them
				
				/*if(!(TheWorld->getTime()%30)) //every second write time info
				{
				sprintf(sBuff, "Journey home - semestral project PB009,by Petr Kudyn (99226).   level %d; speed=%d; vertical_Speed=%d", 
					TheGame->level, int(TheWorld->view->step*100), int(TheWorld->view->verticalStep*100));
				 SetWindowText(hWnd,sBuff); 
				}*/
				TheWorld->view->MoveFront(TheWorld->view->step);
				TheWorld->view->MoveUp(TheWorld->view->verticalStep);
        TheWorld->moveAsteroids();  
				TheWorld->scanFunction();
				TheWorld->ScanCollision();
				TheGame->ScanLevel();
				return 0 ;
	
	case WM_ACTIVATE:							// Watch For Window Activate Message
		   if (!HIWORD(wParam))					// Check Minimization State
				active=TRUE;						// Program Is Active
		   else
		  	active=FALSE;						// Program Is No Longer Active
		   return 0;								// Return To The Message Loop
	 
	case WM_SYSCOMMAND:							// Intercept System Commands
			switch (wParam)							// Check System Calls
			{
				case SC_SCREENSAVE:					// Screensaver Trying To Start?
				case SC_MONITORPOWER:				// Monitor Trying To Enter Powersave?
				return 0;							// Prevent From Happening
			}
			break;									// Exit
	
	case WM_KEYUP:								// Has A Key Been Released?

     switch (wParam)
		 {
	  case VK_SPACE:        //pause animation
		if(TheGame->won) //disable control if won
        return 0;
    	TheWorld->run=!TheWorld->run;  //pause the game
     	 	break;

		case VK_CONTROL:  //indication of new level + F2
		   nl=false;
			 break;

	  case VK_F4:  //restart the game
	 	   delete TheGame;
	     TheGame= new TGame; //create new world
		 SetWindowText(hWnd,"Journey home - semestral project PB009,by Petr Kudyn (99226).   level 1; speed=0; vertical_Speed=0"); //set window text
	     InitGL();          //init gl and load object from file
	     TheWorld->objects[TheWorld->getIndex(FIRST_LEVEL_LIST)]->enabled=true; 
		 break;
	  case VK_F2:
		if(nl)
		{
	     TheGame->NextLevel();
		 if(TheGame->won) //disable sprinf if win
	       break;
	 	 sprintf(sBuff, "Journey home - semestral project PB009,by Petr Kudyn (99226).   level %d; speed=%d; vertical_Speed=%d", 
			    TheGame->level, int(floor(TheWorld->view->step*100+0.5)), int(floor(TheWorld->view->verticalStep*100+0.5)));
	     SetWindowText(hWnd,sBuff);  
		}
	     break;
	  case VK_ESCAPE:  //exit program
		 PostQuitMessage(0);							
		 break;

      case VK_SHIFT:  //start running
         TheWorld->view->angleInc=SLOW_ANGLE;
         break;
		 } 
    return 0;

  case WM_KEYDOWN:								// Has A Key Been Released?
    if(TheGame->won || TheGame->gameOver) //disable control if won
       return 0;
    
	switch (wParam)
		 {
	case VK_CONTROL:   //space for next level with F2
	   nl=true;
	   break;

	 case VK_SHIFT:   //stop running
       TheWorld->view->angleInc=FAST_ANGLE;
        break;
			
	 case VK_RIGHT:           //rotate right
	    if (!TheWorld->run) break;
		  TheWorld->view->Rotate(TheWorld->view->angleInc);
  		break;

	 case VK_LEFT:            //rotate left
      if (!TheWorld->run) break; 
		  TheWorld->view->Rotate(-TheWorld->view->angleInc);
		  break;
		 
	 case VK_UP:             //move front
	 	  if (!TheWorld->run) break;
		  TheWorld->view->incStep(float(STEP_INC));
      break;
		 
	 case VK_DOWN:            //move back
	 	 if (!TheWorld->run) break; 
		 TheWorld->view->incStep(float(-STEP_INC));
     break;
     
	 case VK_PRIOR:   //page up - move up
		  if (!TheWorld->run) break;
		  TheWorld->view->incVerStep(float(VERTICAL_STEP_INC));
		  break;

     case VK_NEXT:   //page down - move down
			 if (!TheWorld->run) break;
			 TheWorld->view->incVerStep(float(-VERTICAL_STEP_INC));
       break;
	  }
		 //upgrade capstion
	  sprintf(sBuff, "Journey home - semestral project PB009,by Petr Kudyn (99226).   level %d; speed=%d; vertical_Speed=%d", 
			TheGame->level, int(floor(TheWorld->view->step*100+0.5)), int(floor(TheWorld->view->verticalStep*100+0.5)));
		SetWindowText(hWnd,sBuff); 
   return 0;

	case WM_CLOSE:								// Did We Receive A Close Message?
			KillTimer (hWnd, TIMER1) ;
	    PostQuitMessage(0);						// Send A Quit Message
			return 0;								// Jump Back
	
	case WM_SIZE:								// Resize The OpenGL Window
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  // LoWord=Width, HiWord=Height
			return 0;								// Jump Back
	}

	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}



// *** main function***
int WINAPI WinMain(	HINSTANCE	hInstance,			// Instance
					HINSTANCE	hPrevInstance,		// Previous Instance
					LPSTR		lpCmdLine,			// Command Line Parameters
					int			nCmdShow)			// Window Show State
{
	MSG		msg;									// Windows Message Structure
	BOOL	done=FALSE;								// Bool Variable To Exit Loop

	TheGame = new TGame;

	fullscreen=FALSE;							// Windowed Mode

	// Create Our OpenGL Window
	if (!CreateGLWindow("Journey home - semestral project PB009,by Petr Kudyn (99226).   level 1; speed=0; vertical_Speed=0",800,600,32,fullscreen))
	{
		return 0;									// Quit If Window Was Not Created
	}
	
	while(!done)									// Loop That Runs While done=FALSE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// Is There A Message Waiting?
		{
			if (msg.message==WM_QUIT)				// Have We Received A Quit Message?
			{
				done=TRUE;							// If So done=TRUE
			}
			else									// If Not, Deal With Window Messages
			{
				TranslateMessage(&msg);				// Translate The Message
				DispatchMessage(&msg);				// Dispatch The Message
			}
		}
		else										// If There Are No Messages
		{
			// Draw The Scene.  Watch For ESC Key And Quit Messages From DrawGLScene()
			if (active)								// Program Active?
			{
				DrawGLScene();					// Draw The Scene
				SwapBuffers(hDC);				// Swap Buffers (Double Buffering)
			}
		}
	}

	// Shutdown
	KillGLWindow();									// Kill The Window
	return (msg.wParam);							// Exit The Program
}
