/*
 *	main.h - include common headers and libraries
 *  	
 *  
 *  Petr Kudyn (99226)
 *	PB009 - spring 2004
 *
 */
#ifndef MAINH
#define MAINH

#pragma comment (lib,"opengl32.lib")
#pragma comment (lib,"glu32.lib")
#pragma comment (lib,"glaux.lib")
#pragma comment (lib,"winmm.lib")


#include <windows.h>		// Header File For Windows
#include <stdio.h>      // Header File for standart input/output

InitGL();


#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library

#define MAXPATH 515            //maximum size of program path
#define OBJECT_FILE_NAME "objects.txt"  //implicit file with objects
#define MAX_LINE_LENGTH 255   //max line length in object file
#define TIMER1 1              //ID of timer 1
#define TIMER1_PERIOD 30        //time period in miliseconds
#define TIME_CONST 3     //times are multipied by this to achive possibility set times in 1/10 sec
                         //const is derived from TIMER1_PERIOD  as cca 1000/TIMER1_PERIOD
#define PI 3.14159265358979323846   //Pi

#define STEP_INC 0.01  //horizontal step increment
#define MAX_STEP 0.1    //maximal horizontal step 

#define FAST_ANGLE 3   //angle increment when going
#define SLOW_ANGLE 1   //angle increment when running  

#define VERTICAL_STEP_INC 0.01 //vertical step increment
#define MAX_VERTICAL_STEP 0.05//maximal vertical step  

#define BORG 0 //borg texture number
#define ASTEROID 1 //asteroid texture

#define MIN_AST_SIZE 0.10f //minimum astereoid size (radius)
#define MAX_AST_SIZE 0.750f //maximum asteroid size (radius)

#define MIN_R  0.4f  //minumum R color for asteroids
#define MAX_R  1.0f  //maxumum R color for asteroids
#define MIN_G  0.2f  //minumum G color for asteroids
#define MAX_G  1.0f  //maxumum G color for asteroids
#define MIN_B  0.5f  //minumum B color for asteroids
#define MAX_B  1.0f  //maxumum B color for asteroids

#define MIN_SPEED  -0.1f  //minumum speed for asteroids
#define MAX_SPEED  0.1f   //maxumum speed for asteroids

#define MIN_ROT -2.0f //minimum rotation speed
#define MAX_ROT 2.0f //maximum rotation speed

#define CUBE_SIZE 0.16f //length of cube edge

#define NUM_LEVEL 10  //number of levels

#define FIRST_LEVEL_LIST 13  //number of fisrt number in velel casption 
#define FIRST_WIN_ID   30  //id of first number of congratutaions
#define NUM_WIN   53  //number of letters in congratutaions
#define LIGHT_WIN 2 //id of light for congratulations


#endif